﻿--[[ 	GupPet by Gup 	]]--

-- CONSTANT

-- SAVED VARS
GUPPET_CM_TEMPDATA = { TotalKnownMounts = 0 , TotalKnownCompanions = 0  } ;

-- TEMP VARS
GUPPET_CM_PLAYER = { Faction ="" , Race = "" , Class = ""   } ;
	-- PlayerFaction --> Allience = 1 , Horde --> 2
	-- PlayerClass --> PALADIN --> 1,  DEATHKNIGHT --> 2,  WARLOCK --> 3 , "MAGE", "WARRIOR", "HUNTER", "DRUID", "SHAMAN", "PRIEST" ,

	

-- // At Loading // --
function GupPet_CollectMe_OnLoad(self)

	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("COMPANION_LEARNED");
end

-- // Event Handlers. // --
function GupPet_CollectMe_OnEvent(self, event) --self, event, ...

	if event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		
		
		if  UnitFactionGroup("player") == "Horde" then GUPPET_CM_PLAYER.Faction = 2 else GUPPET_CM_PLAYER.Faction = 1 end
		_, GUPPET_CM_PLAYER.Race  = UnitRace("player");
		
		local _, Class = UnitClass("player");
		if Class == "PALADIN" then GUPPET_CM_PLAYER.Class = 1
		elseif Class == "DEATHKNIGHT" then GUPPET_CM_PLAYER.Class = 2
		elseif Class == "WARLOCK" then GUPPET_CM_PLAYER.Class = 3
		else GUPPET_CM_PLAYER.Class = nil end
		
		
		GupPet_CollectMe_SearchMounts();
		GupPet_CollectMe_Interface();
		
	elseif event == "VARIABLES_LOADED" then
	
		
			
	elseif event == "COMPANION_LEARNED" then

		GupPet_CollectMe_SearchMounts();
		GupPet_CollectMe_Interface();
	
	end

	
	
	
end

function GupPet_CollectMe_SearchMounts()
 
	
	
	-------------------------------------
	-- Mount
	GUPPET_CM_TEMPDATA["UnknownMounts"] = {} ;
	GUPPET_CM_TEMPDATA["KNOWNMOUNTS"] = {} ;
 
	
	for i=1, GetNumCompanions("MOUNT") do
    
		local creatureID, name, spellID, icon, active = GetCompanionInfo("MOUNT", i);
       
		GUPPET_CM_TEMPDATA["KNOWNMOUNTS"][spellID] = true;
		GUPPET_CM_TEMPDATA.TotalKnownMounts = i ;
    end
 
	for k,v in pairs(GUPPET_CM_DATA["Mounts"]) do
  
		if GUPPET_CM_TEMPDATA["KNOWNMOUNTS"][k] == nil then
 
			if v.Faction == nil or v.Faction == GUPPET_CM_PLAYER.Faction then
				if not ( v.Class and v.Class ~= GUPPET_CM_PLAYER.Class ) then
					
					name, _, icon = GetSpellInfo(k);
					table.insert( GUPPET_CM_TEMPDATA["UnknownMounts"] , { Name = name , Icon = icon , Id = k, CreatureID = v.Id   } );
					
				end
			end
		end
	end
	
	table.sort(GUPPET_CM_TEMPDATA["UnknownMounts"] , GupPet_CollectMe_SortTableByName);

	-------------------------------------
	-- Companion
	GUPPET_CM_TEMPDATA["UnknownCompanions"] = {} ;
	GUPPET_CM_TEMPDATA["KnownCompanions"] = {} ;
	 
	for i=1, GetNumCompanions("CRITTER") do
    
		local creatureID, name, spellID, icon, active = GetCompanionInfo("CRITTER", i);
       
		GUPPET_CM_TEMPDATA["KnownCompanions"][spellID] = true;
		GUPPET_CM_TEMPDATA.TotalKnownCompanions = i ;
    end
 
	for k,v in pairs(GUPPET_CM_DATA["Companions"]) do
  
		if GUPPET_CM_TEMPDATA["KnownCompanions"][k] == nil then
 
			if v.Faction == nil or v.Faction == GUPPET_CM_PLAYER.Faction then
									
				name, _, icon = GetSpellInfo(k);
				table.insert( GUPPET_CM_TEMPDATA["UnknownCompanions"] , { Name = name , Icon = icon , Id = k, CreatureID = v.Id   } );
					
				
			end
		end
	end
	
	table.sort(GUPPET_CM_TEMPDATA["UnknownCompanions"] , GupPet_CollectMe_SortTableByName);	
	
	
 end
 